#!/usr/bin/env python
# ------------------------------------------------
#  These Functions give you examples of how to fill 
#  in the request messasges.
#
# ------------------------------------------------
import sys, time, threading, getopt, socket
from run import *
from pyGridWare.ogsi.dispatch import AsServer

from pyGridWare.ogsi.config import ConfigImportHandler
from pyGridWare.ogsi.Utilities import HandleResolverDomAid

import_handler = ConfigImportHandler()
import_handler()
module_name = 'pyGridWare.ogsi.services.NotificationFactoryService_services'
ogsi = import_handler.getMessageModuleByName(module_name)
ns1 = ogsi.ns1

module_name = 'pyGridWare.ogsi.services.OGSI_services'
ogsi2 = import_handler.getMessageModuleByName(module_name)
ns2 = ogsi2.ns1


class NotificationCallbackHandler(threading.Thread):
    """ Notification Sink Messages and required basic 
        client-side message handling functionality.
      
        Class Variables:
            port -- default port
            path -- default path
            host -- default host
 
        OGSI Operations: 
            deliverNotification -- notification sink
            findByHandle -- GSH resolutions

    """
    port = 10000
    path = '/ogsa/services/core/NotificationSink'
    host = socket.gethostbyname(socket.gethostname())

    def __init__(self, thread_name=None, **kw):
        """
            Keywords:
              host 
              port 
              path
        """
        threading.Thread.__init__(self, None, thread_name)
        self._modules = [self]
        self._typesmodules = import_handler.getMessageList()
        self._host = kw.get('host', self.host)
        path = kw.get('path', self.path)
        self._port = kw.get('port', self.port)
        self._handle = 'http://%s:%d%s' %(self._host, self._port, path)

    def run(self):
        AsServer(port=self._port,
            modules=self._modules, 
            docstyle=1,
            typesmodule=self._typesmodules) 

    def deliverNotification(self, *args):
        print "def deliveryNotification(*args):"
        msg = args[0]
        print "\tmessage = ", getattr(msg,'_message')

    def findByHandle(self, *args):
        print "def findByHandle(*args):"
        pyobj = ogsi2.FindByHandleOutputMessageWrapper()
        pyobj._locator = ns1.LocatorType_Def(name="locator")
        pyobj._locator._reference = ns1.WSDLReferenceType_Def(name='reference')
        resolver = HandleResolverDomAid(handle=self._handle,
                       hostport=(self._host,self._port)
                       )
        pyobj._locator._reference._dom = resolver.getReference()
        return pyobj

