###############################################################################
# HELPER FUNCTIONS
# --WSDL Definition DOM
###############################################################################

class SubscriptionReferenceDomAid:
    def getSubscribeOutputMessage(self, request, addr, port):
        """------------------------------------------
       ----------------------------------------------
      <subscribe xmlns="http://www.gridforum.org/namespaces/2003/03/OGSI">
       <subscriptionExpression>
        <subscribeByServiceDataNames xsi:type="ns1:SubscribeByNameType" 
            xmlns:ns1="http://www.gridforum.org/namespaces/2003/03/OGSI">
         <name>entry</name>
        </subscribeByServiceDataNames>
       </subscriptionExpression>
       <sink>
        <handle>http://192.168.1.2:32965/ogsa/services/sinks/1066769825928-192.168.1.2-32965-13390902-11320634</handle>
       </sink>
       <expirationTime>2003-10-21T21:57:07.247Z</expirationTime>
      </subscribe>
       ----------------------------------------------
       ----------------------------------------------
      <subscribeResponse xmlns="http://www.gridforum.org/namespaces/2003/03/OGSI">
       <subscriptionInstanceLocator 
           xsi:type="ns1:LocatorType" 
           xmlns:ns1="http://www.gridforum.org/namespaces/2003/03/OGSI">
          <reference xsi:type="ns1:WSDLReferenceType">
            <definitions name="OGSINotificationSubscription" 
                targetNamespace="http://www.gridforum.org/namespaces/2003/03/OGSI/service" 
                xmlns="http://schemas.xmlsoap.org/wsdl/" 
                xmlns:ogsibinding="http://www.gridforum.org/namespaces/2003/03/OGSI/bindings" 
                xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/">
              <import location="http://192.168.1.2:8081/schema/ogsi/ogsi_bindings.wsdl" 
                      namespace="http://www.gridforum.org/namespaces/2003/03/OGSI/bindings"/>
              <service name="OGSINotificationSubscription" 
                       xmlns:gsdl="http://ogsa.globus.org/">
                  <gsdl:instanceOf handle="http://192.168.1.2:8081/ogsa/services/ogsi/NotificationSubscriptionFactoryService/hash-26675936-1066769829203" xmlns=""/>
                  <gsdl:instanceOf handle="http://192.168.1.2:8081/ogsa/services/instance" xmlns=""/>
                  <port binding="ogsibinding:NotificationSubscriptionSOAPBinding" 
                        name="NotificationSubscriptionPort">
                      <soap:address location="http://192.168.1.2:8081/ogsa/services/ogsi/NotificationSubscriptionFactoryService/hash-26675936-1066769829203"/>
                  </port>
              </service>
            </definitions>    
        </reference>
       </subscriptionInstanceLocator>
       <ns2:currentTerminationTime xsi:type="ns2:TerminationTimeType" 
           ns2:after="2003-10-21T21:57:07.247Z" 
           ns2:before="2003-10-21T21:57:07.247Z" 
           ns2:timestamp="2003-10-21T20:57:09.237Z" 
           xmlns:ns2="http://www.gridforum.org/namespaces/2003/03/OGSI"/>
      </subscribeResponse>
       ----------------------------------------------
        """
        #request._subscriptionExpression
        #request._subscriptionExpression._subscribeByServiceDataNames
        #request._subscriptionExpression._subscribeByServiceDataNames._name
        #request._sink
        #request._sink._handle
        #request._expirationTime

        url = '/ogsa/services/sinks'
        pyobj = SubscribeOutputMessageWrapper()
        pyobj._currentTerminationTime = Holder()
        pyobj._subscriptionInstanceLocator._reference = \
            ns2.WSDLReferenceType_Def(name='reference')

        resolver = HandleResolverDomAid(handle=url, hostport=(addr,port))
        try:
            pyobj._subscriptionInstanceLocator._reference._dom = resolver.getReference()
        except Exception, ex:
            raise

        return pyobj


###############################################################################
#  BELOW -- REMOVE THIS STUFF
###############################################################################
def main():
    import socket
    from StringIO import StringIO
    import ZSI
    crs = ContainerRegistryService(
              addr=socket.gethostbyname(socket.gethostname()),
              port=8080
              )
    #pyobj = crs.getFindServiceDataOutputMessage(1)
    #pyobj = crs.getFindByHandleResponse(msg=None)
    pyobj = GetSubscribeOutputMessage(None)
    print "MSG: ", pyobj
    s = StringIO()
    sw = ZSI.SoapWriter(s)
    sw.serialize(pyobj)
    print "RESULT -----\n", s.getvalue()

if __name__ == '__main__':
    main()

