import ZSI
from ZSI import _attrs
from StringIO import StringIO
from xml.dom.ext.reader import PyExpat
from OGSI_services import FindByHandleOutputMessage, ns1, Struct
import NotificationFactoryService_services
TerminationTimeType = NotificationFactoryService_services.ns1.TerminationTimeType

ADDR = None
PORT = None
DEBUG = 0



def print_debug(msg, arg=None):
    if DEBUG and arg:
        print "<MOD>:  %s" %msg, arg
    elif DEBUG:
        print "<MOD>:  %s" %msg

#
# ZSI.TC.XML does inline serilization
#    with the pname not oname??
#
class myXML(ZSI.TC.XML):
    def cb(self, sw, pyobj):
        if sw.Known(pyobj): return
        objid = '%x' % id(pyobj)
        n = self.oname or self.pname or ('E' + objid)
        print >>sw, '<%s SOAP-ENC:encodingStyle="" id="%s">' % (n, objid)
        ZSI.TC.Canonicalize(pyobj, sw, comments=self.comments)

        # ignore the xmlns if it was explicitly stated
        i = n.find('xmlns')
        if i > 0:
            print >>sw, '</%s>' % n[:i - 1].strip()
        else:
            print >>sw, '</%s>' % n



class DeliverNotificationResponse(ZSI.TC.TypeCode):
    def __init__(self, name=None):
        ZSI.TC.TypeCode.__init__(self)

DeliverNotificationResponse.typecode = \
    ZSI.TC.Struct(pyclass=DeliverNotificationResponse,ofwhat=[],pname='deliverNotificationResponse', oname=r'deliverNotificationResponse xmlns="http://www.gridforum.org/namespaces/2003/03/OGSI"')


class DeliverNotificationInput(ZSI.TC.TypeCode):
    def __init__(self, name=None):
        ZSI.TC.TypeCode.__init__(self)
DeliverNotificationInput.typecode = \
    ZSI.TC.Struct(
        pyclass=DeliverNotificationInput,
        ofwhat=[],
        pname='deliverNotification', 
        oname=r'deliverNotification xmlns="http://www.gridforum.org/namespaces/2003/03/OGSI"'
    )

class Holder: pass

"""
class TerminationTimeType(ZSI.TCcompound.Struct):
    #tag = 'ns1:TerminationTimeType'
    def parse(self, elt, ps):
        attributes_dict = {}
        for attr in _attrs(elt):
            attributes_dict[attr.name] = attr.value
        pyobj =  ZSI.TCcompound.Struct.parse(self, elt, ps)
        pyobj.attributes_dict = attributes_dict
        return pyobj
"""
        

def deliverNotification(*args):
    print_debug('#'*50)
    print_debug('delivery confirmation: ', args)
    print_debug('#'*50)
    element = args[0]
    from xml.dom.ext import PrettyPrint
    
    xml = StringIO()
    PrettyPrint(element, stream=xml)
    myXml =  xml.getvalue()
    print_debug(myXml)
    message = """
<SOAP-ENV:Envelope
  xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:ZSI="http://www.zolera.com/schemas/ZSI/" 
  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" 
  xmlns:ns1="http://www.gridforum.org/namespaces/2003/03/OGSI" >
<SOAP-ENV:Body> %s
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>""" %myXml

    try:
        ps = ZSI.parse.ParsedSoap(message)
    except Exception, ex:
        print_debug('*'*100)
        print_debug(ex)
        return
    print_debug("PS: ", ps)

    #Find TypeCode to Use.
    try:
        #ofwhat=[Struct(pyclass=Holder, ofwhat=[TerminationTimeType(pyclass=Holder, ofwhat=[], pname='terminationTime')], pname='serviceDataValues')]
        ofwhat=[TerminationTimeType(name='terminationTime')]
        ofwhat=[Struct(pyclass=Holder, ofwhat=ofwhat, pname='serviceDataValues')]
        ofwhat = [Struct(pyclass=Holder, ofwhat=ofwhat, pname="message")]
    except Exception, ex:
        print_debug('*'*100)
        print_debug(ex)
        return

    try:
        tc = Struct(pyclass=Holder, ofwhat=ofwhat, pname='deliverNotification')
        pyobj = ps.Parse(tc)
    except Exception, ex:
        print_debug('*'*100)
        print_debug(ex)
        return

    print "\/"*30
    print "message: ", pyobj.message
    print "\tserviceDataValues -- ", pyobj.message.serviceDataValues
    print "\t\tterminationTime -- ", pyobj.message.serviceDataValues._terminationTime
    for k,v in pyobj.message.serviceDataValues._terminationTime.attributes_dict.items():  
        print "\t\t\t%s  -- %s" %(k,v)
    print "\/"*30

    return DeliverNotificationResponse()

def findByHandle(*args):
    print_debug('#'*50)
    print_debug('findByHandle: ', args)
    print_debug('#'*50)
    #return findByHandleResponse()
    #return getFindByHandleResponse()
    return main()


class Locator(ZSI.TC.TypeCode, ZSI.TC.Struct):
    def __init__(self, name=None):
        self._reference = None
        ofwhat = [\
            myXML(pname='reference', 
                aname='_reference', 
                oname='reference  %s  %s' %('xmlns:ns1="http://www.gridforum.org/namespaces/2003/03/OGSI"', 'xsi:type="ns1:WSDLReferenceType"'),
                optional=1,
                inline=1)
        ]

        ZSI.TC.Struct.__init__(self,
            pyclass=self.__class__, 
            ofwhat=ofwhat,
            pname='locator', 
            aname='_locator',
            oname='locator %s  %s' %('xmlns:ns1="http://www.gridforum.org/namespaces/2003/03/OGSI"',
                'xsi:type="ns1:LocatorType"')
        )


class FindBH(ZSI.TC.TypeCode):
    def __init__(self, name=None):
        self._locator = Locator()
        ZSI.TC.TypeCode.__init__(self, name='findByHandleResponse')

FindBH.typecode = \
    ZSI.TC.Struct(
        pyclass=FindBH, 
        ofwhat=[Locator()], 
        pname='findByHandleResponse',
        oname = 'findByHandleResponse  xmlns="http://www.gridforum.org/namespaces/2003/03/OGSI"')

def getWSDLDefinitionDOM():
    print_debug('def getWSDLDefinitionDOM():')
    wsdl = """
<definitions name="OGSINotificationSink" 
    targetNamespace="http://www.gridforum.org/namespaces/2003/03/OGSI/service" 
    xmlns="http://schemas.xmlsoap.org/wsdl/" 
    xmlns:ogsibinding="http://www.gridforum.org/namespaces/2003/03/OGSI/bindings" 
    xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/">
    <import location="http://%s:%d/schema/ogsi/ogsi_bindings.wsdl" 
            namespace="http://www.gridforum.org/namespaces/2003/03/OGSI/bindings"/>
    <service name="OGSINotificationSinkService" 
             xmlns:gsdl="http://ogsa.globus.org/">
         <gsdl:instanceOf handle="http://%s:%d/ogsa/services/sinks/10612" xmlns=""/>
         <port binding="ogsibinding:NotificationSinkSOAPBinding" 
               name="NotificationSinkPort">
             <soap:address location="http://%s:%d/ogsa/services/sinks/10612"/>
         </port>
    </service>
</definitions>""" %(ADDR, PORT, ADDR, PORT, ADDR, PORT)
    reader = PyExpat.Reader()
    return reader.fromString(wsdl)

def getFindByHandleResponse():
    dom = getWSDLDefinitionDOM()
    pyobj = FindBH()
    pyobj._locator._reference = dom
    return pyobj

def main():
    pyobj = FindByHandleOutputMessage()
    del pyobj.typecode

    pyobj._locator._reference = ns1.WSDLReferenceType(name='reference')
    try:
        pyobj._locator._reference._dom = getWSDLDefinitionDOM()
    except Exception, ex:
        print ex
        return
    del pyobj.__class__.typecode.ofwhat[0].typecode

    pyobj.__class__.typecode.ofwhat[0].oname = '%s  %s  %s' %('locator',
        'xmlns:ns1="http://www.gridforum.org/namespaces/2003/03/OGSI"',
        'xsi:type="ns1:LocatorType"')

    #COPY IT TO DERIVED TYPE
    pyobj.__class__.typecode.ofwhat[0].ofwhat[1].oname = '%s  %s  %s' %('reference',
        'xmlns:ns1="http://www.gridforum.org/namespaces/2003/03/OGSI"',
        'xsi:type="ns1:WSDLReferenceType"')
    pyobj._locator._reference.oname = pyobj.__class__.typecode.ofwhat[0].ofwhat[1].oname

    s = StringIO()
    sw = ZSI.SoapWriter(s)
    sw.serialize(pyobj)
    print "RESULT -----\n", s.getvalue()
    return pyobj
    
 
if __name__ == '__main__': 
    main()
