#! /usr/bin/env python
# $Header: /home/portnoy/u5/repository/pyGridWare/pyGridWare/ogsi/dispatch.py,v 1.15 2003/12/18 01:41:45 boverhof Exp $

import types, os, sys, cStringIO as StringIO
from SimpleHTTPServer import SimpleHTTPRequestHandler
from ZSI import *
from ZSI import _child_elements, _copyright, _seqtypes, resolvers
from ZSI.auth import _auth_tc, AUTH, ClientBinding

from pyGridWare.ogsi.services.GridService import Reference

#from pyGridWare.ogsi.services.OGSIBaseServices import FactoryBase
#from pyGridWare.ogsi.services.OGSIServices import HandleResolverService
#from pyGridWare.ogsi.services.OGSIHandleResolverService import OGSIHandleResolverService

from pyGridWare import getLogger
logger = getLogger(__name__)

DEBUG = 0
def print_debug(msg, arg=None):
    if DEBUG and arg:
        print "<DISPATCH>  %s" %msg, arg
    elif DEBUG:
        print "<DISPATCH>  %s" %msg


def ByPostFindCallBack(what, node_tree, post=None):
    '''Use POST to find correct set of node_tree, then
       return function.
    '''
    # Of those node_tree, check for matching post in class
    logger.info("POST: %s", post)
    print "Node Tree: ", node_tree
    node = node_tree.getNode(post)
    print "NODE: ", node
    
    if node:
        if type(node) == types.InstanceType and hasattr(node, what):
            handlers = [getattr(node, what),]
    else:
        logger.info("**Check all instances, Cant find POST")
        #handlers = [ getattr(m, what) for m in node_tree if hasattr(m, what) ]

    if len(handlers) == 0:
        raise TypeError("Unknown method " + what)

    # Of those node_tree, see who's callable.
    handlers = [ h for h in handlers if callable(h) ]
    if len(handlers) == 0:
        raise TypeError("Unimplemented method " + what)
    if len(handlers) > 1:
        raise TypeError("Multiple implementations found: " + `handlers`)
    return handlers[0]

def _Dispatch(ps, modules, SendResponse, SendFault, docstyle=0,
              nsdict={}, typesmodules=None, rpc=None, post=None, **kw):
    '''Find a handler for the SOAP request in ps; search modules.
    Call SendResponse or SendFault to send the reply back, appropriately.

        typesmodules -- list or a dictionary(namespace keyed) of modules 
            containing message classes which are TypeCodes.
        post -- HTTP POST value.  Use this for dispatching.
    '''
    try:
        what = ps.body_root.localName

        try:
             handler = ByPostFindCallBack(what, Reference.node_tree, post=post)
        except Exception, ex:
            raise

        if docstyle:
            print_debug("typesmodules: ", typesmodules)
            if typesmodules:
                element_dec = ps.body_root.localName
                element_ns = ps.body_root.namespaceURI
                print_debug("ELEMENT:  ", (element_dec, element_ns))

                #tc = getattr(typesmodule, type).typecode
                #type_prefix, type_def = SplitQName(_find_type(c_elt))
                #if type_def: 
                #    if type_prefix:
                #        type_ns = my_elt.attributes.get((XMLNS.BASE, tfix))
                #    else:
                #        type_ns = element_ns
                try:
                    if type(typesmodules) == types.DictType: 
                        if typesmodules.has_key(element_ns):
                            typesmodules = (typesmodules[element_ns],)
                        else:
                            typesmodules = typesmodules.values()

                    for typesmodule in typesmodules:
                        print_debug("********************************* ", typesmodule)
                        for tp in typesmodule.__dict__.values():
                            if types.ClassType == type(tp):
                                if hasattr(tp, 'typecode'):
                                    print_debug("(%s)------------------------> " %tp.typecode.pname, tp)
                                    if tp.typecode.pname != element_dec or\
                                       tp.typecode.schema != element_ns:
                                        continue
                                    print_debug("TYPECODE:  ", tp.typecode)
                                    arg = tp.typecode.parse(ps.body_root, ps)
                                    print_debug("ARG:  ", arg)
                                    print_debug("Handler:  ", handler)
                                    result = handler(arg)
                                    break
                        else:
                            continue
                        break
                    else:
                        print_debug("NO Type(%s) IN TYPESMODULE: " %element_dec, typesmodules)
                        result = handler(ps.body_root)
                except Exception, ex: 
                    print_debug("EXCEPTION: ", ex)
                    raise
            else:
                result = handler(ps.body_root)

        else:
            data = _child_elements(ps.body_root)
            if len(data) == 0:
                arg = []
            else:
                try:
                    try:
                        element_dec = data[0].localName
                        element_ns = data[0].namespaceURI
                        for typesmodule in typesmodules:
                            tc = getattr(typesmodule, element_dec).typecode
                            if hasattr(typesmodule, element_dec) and \
                                hasattr(getattr(typesmodule, element_dec), 'typecode'):
                                tc = getattr(typesmodule, element_dec).typecode
                                break
                        else:
                            raise RuntimeError, 'failure in dispatch rpc support'
                    except Exception, e:
                        tc = TC.Any()
                    arg = [ tc.parse(e, ps) for e in data ]
                except EvaluateException, e:
                    SendFault(FaultFromZSIException(e), **kw)
                    return
            result = [ handler(*arg) ]
        reply = StringIO.StringIO()

        print_debug("RESULT: ", result)
        if isinstance(result, tuple):
            tc = result[0].typecode
            result = result[1]
        elif hasattr(result, 'typecode'):
            tc = result.typecode
        else:
            raise RuntimeError,\
                'Dispatch needs result return from module to be self describing'

        SoapWriter(reply, nsdict=nsdict).serialize(result, tc, rpc=rpc)
        soapdata = reply.getvalue()
        # Tracing?
        if kw.has_key('tracefile'):
            print >>kw['tracefile'], "_" * 33, time.ctime(time.time()), "DISPATCH RESPONSE:"
            print >>kw['tracefile'], soapdata
        return SendResponse(soapdata, **kw)
    except Exception, e:
        # Something went wrong, send a fault.
        return SendFault(FaultFromException(e, 0, sys.exc_info()[2]), **kw)


class SOAPRequestHandler(SimpleHTTPRequestHandler):
    '''SOAP handler.
    '''
    server_version = 'ZSI/1.1 ' + SimpleHTTPRequestHandler.server_version

    def __init__(self, request, client_address, server):
        """For now if instance has a soap_handler variable, set this to
           self so the instance can inform the handler of any newly created
           instances.   Allows for the factory pattern.
        """
        SimpleHTTPRequestHandler.__init__(self, request, client_address, server)

    def send_xml(self, text, code=200):
        '''Send some XML.
        '''
        self.send_response(code)
        self.send_header('Content-type', 'text/xml; charset="utf-8"')
        self.send_header('Content-Length', str(len(text)))
        self.end_headers()
        self.wfile.write(text)
        self.wfile.flush()

    def send_fault(self, f):
        '''Send a fault.
        '''
        self.send_xml(f.AsSOAP(), 500)

    def do_POST(self):
        '''The POST command.
        '''
        try:
            ct = self.headers['content-type']
            if ct.startswith('multipart/'):
                cid = resolvers.MIMEResolver(ct, self.rfile)
                xml = cid.GetSOAPPart()
                ps = ParsedSoap(xml, resolver=cid.Resolve)
            else:
                length = int(self.headers['content-length'])
                #ps = ParsedSoap(self.rfile.read(length))
                input = self.rfile.read(length)
                ps = ParsedSoap(input)
                print_debug("RECEIVE: \n", input)
        except ParseException, e:
            self.send_fault(FaultFromZSIException(e))
            return
        except Exception, e:
            # Faulted while processing; assume it's in the header.
            self.send_fault(FaultFromException(e, 1, sys.exc_info()[2]))
            return

        _Dispatch(ps, self.server.modules, self.send_xml, self.send_fault,
                  docstyle=self.server.docstyle, nsdict=self.server.nsdict,
                  typesmodules=self.server.typesmodule, rpc=self.server.rpc, 
                  post=self.path)


class GridServiceRequestHandler(SOAPRequestHandler):
    """ For a single dispatch event.  All state information must be pushed 
        into self.server.modules
    """
    server_version = 'pyGridWare/1.1 ' + SimpleHTTPRequestHandler.server_version

    def __init__(self, request, client_address, server):
        """ Expects server.modules to be a list of GridService instances.
            It will inform all the Factories of how to call back to the
            Handler so it can add a service to the self.server.modules.
            It will also look for the HandleResolver service, which it 
            will register any newly created instances with. 
        """
        SOAPRequestHandler.__init__(self, request, client_address, server)
        #self.handle_resolver = self.server.modules.getNode('/ogsa/services/core/registry//handleResolver')

        #if not self.handle_resolver:
        #     raise RuntimeError, 'must have a handle resolver'

    def addService(self, service):
        """Registers a new callback instance with the handler, called
           by a factory service when it creates an instance of something

           service -- service instance, defining callback functions.
        """
        #self.setHandlerForService(service)
        #self.server.modules.append(service)
        #self.handle_resolver.register(service=service)
        raise RuntimeError, 'this method is to be removed'

    def setHandlerForService(self, service):
        """Checks to see if service is a factory, then inform it about the
           handler. So the instance can inform the handler of any newly created
           instances.   Allows for the factory pattern.
        """
        #if type(service) == types.InstanceType and isinstance(service, FactoryBase):
        #    service.setSoapHandler(self)
        raise RuntimeError, 'this method is to be removed'



