############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
#
###########################################################################

import time
from pyGridWare.ogsi.samples.Counter_services import \
    AddOutputMessageWrapper,\
    SubtractOutputMessageWrapper,\
    GetValueOutputMessageWrapper

from pyGridWare.ogsi.services.OGSIBaseServices import GridService, FactoryBase
""" CounterServices

    This is one of the modules passed to dispatch for the stand-alone server.

    CounterService

    CounterFactoryService
"""

class CounterService(GridService):

    def __init__(self, addr, port, post, reference):
        GridService.__init__(self, addr, port, post, reference)
        self._value = 0

    def getValue(self, *args):
        pyobj = GetValueOutputMessageWrapper()
        pyobj._returnValue = self._value
        return pyobj

    def add(self, msg):
        pyobj = AddOutputMessageWrapper()
        self._value += msg._value
        pyobj._returnValue = self._value
        return pyobj

    def subtract(self, msg):
        pyobj= SubtractOutputMessageWrapper()
        self._value -= msg._value
        pyobj._returnValue = self._value
        return pyobj


class CounterFactoryService(FactoryBase):
    """ class variables:
        --instance: sets type of service to be created.
        --instance_reference: reference of service to be created.
    """
    instance = CounterService
    instance_reference = 'schema/samples/counter/notification_counter_service.wsdl' 

    def __init__(self, addr, port, post, reference):
        FactoryBase.__init__(self, addr, port, post, reference)
    
    def createService(self, msg):
        return FactoryBase.createService(self, msg)

