############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################

from xml.dom.ext.reader import PyExpat
#from xml.dom.ext import c14n
from pyGridWare.ogsi import security as c14n

class ElementProxy:
    def __init__(self, doc):
        self._doc = doc
        self._reader = PyExpat.Reader()
        self._curi = None
        self._canonFunction = c14n.Canonicalize
        
    def fromString(self, xmlStr):
        return self._reader.fromString(xmlStr)

    def getDocument(self):
        return self._doc

    def getCanonicalizationURI(self):
        return self._curi

    def getCanonicalizationFunction(self):
        return self._canonFunction

    def setDocument(self, doc):
        self._doc = doc

    def setCanonicalizationURI(self, curi):
        self._curi = curi

    def setCanonicalizationFunction(self, canonicalizationFunction):
        self._canonFunction = canonicalizationFunction

    def canonicalize(self, node, **kw):
        """return c14n string, alternative using kw to be added
        """
        return self._canonFunction(node, **kw)
