############################################################################
# Joshua R. Boverhof, David W. Robertson, LBNL
# See Copyright for copyright notice!
###########################################################################
from xml.ns import SOAP, ENCRYPTION
from Ft.Xml import XPath
from pyGridWare.ogsi.security.ElementProxy import ElementProxy
from pyGridWare.ogsi.security import WSSE


class EncryptedData(ElementProxy):
    """
      <xenc:EncryptedData xmlns:xenc="http://www.w3.org/2001/04/xmlenc#" Id="EncryptedBody" Type="http://www.w3.org/2001/04/xmlenc#Element">
        <xenc:EncryptionMethod Algorithm="http://www.globus.org/2002/04/xmlenc#gssapi-enc"></xenc:EncryptionMethod>
          <ds:KeyInfo xmlns:ds="http://www.w3.org/2000/09/xmldsig#">
            <ds:KeyName>00000000-0064-023c-00000000-0000012e7cb6</ds:KeyName>
          </ds:KeyInfo>
        <xenc:CipherData>
          <xenc:CipherValue>
             ...
          </xenc:CipherValue>
        </xenc:CipherData>
      </xenc:EncryptedData>
    """
    processorNss = {\
        'soapenv':SOAP.ENV,
        'wsse':WSSE.BASE,
        'xenc':ENCRYPTION.BASE,
        'ds':DSIG.BASE,
        }
    CanonicalizationMethod = "http://www.w3.org/TR/2001/REC-xml-c14n-20010315"
    EncryptionMethod = "http://www.w3.org/2002/04/xmlenc#gssapi-enc"
    EncryptedDataType = "http://www.w3.org/2001/04/xmlenc#Element"
    encDataExp = XPath.Compile('soapenv:Envelope/soapenv:Body/xenc:EncryptedData')

    def __init__(self, doc):
        ElementProxy.__init__(self, doc)
        self.setCanonicalizationURI(self.CanonicalizationMethod)
        self._encMethod = self.EncryptionMethod

    def getEncryptionMethodURI(self):
        """Returns the Encryption method URI  
        """
        return self._encMethod

    def setEncryptionMethodURI(EncryptionMethodURI):
        """Sets the Encryption method URI  
        """
        return

    def encrypt(self):
        """Data encrypt  
        """
        return

    def decrypt(self):
        """Data decrypt
        """
        return

