############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
#
###########################################################################
import urlparse

from pyGridWare.ogsi.services.OGSI_services import \
    FindByHandleOutputMessageWrapper, ns1

from pyGridWare.ogsi.services.NotificationFactoryService_services import \
    SubscribeOutputMessageWrapper

from pyGridWare.ogsi.services.NotificationFactoryService_services import \
    ns1 as ns2

from pyGridWare.ogsi.HandleResolvers import \
    SubscriptionReferenceDomAid

from pyGridWare.ogsi.services.OGSIBaseServices import GridService, NotificationSource, Holder
    
""" OGSIServices

     This is one of the modules passed to dispatch for the stand-alone server.
    This module should define GridService interactions.

    HandleResolver 
        findByHandle -- sort of works
  
    ServiceData
        findServiceData -- need to store and retrieve these values

    Notification 
        subscribe
        deliverConfimation

"""

DEBUG = 0
def print_debug(msg, arg=None):
    if DEBUG and arg:
        print "<OGSIServices>:  %s" %msg, arg
    elif DEBUG:
        print "<OGSIServices>:  %s" %msg


class ContainerRegistryService(NotificationSource):
    """This is just a NotificationServiceGroupService instance.
    """

    def __init__(self, addr, port, post, reference):
        NotificationSource.__init__(self, addr, port, post, reference)
        self.entries = []
        handle = "http://%s:%d/ogsa/services/samples/counter/notification/CounterFactoryService"\
                     %(self.addr,self.port)
        self.addEntry(handle=handle)

    def setStartUpServices(self, services):
        for s in services:
            if not isinstance(s, NotificationSource):
                 raise RuntimeError, 'all services must be instances of NotificationSource)'
            s.post

    def findServiceData(self, msg):
        return NotificationSource.findServiceData(self, msg)


class HandleResolverService(GridService):

    def __init__(self, addr, port, post, reference):
        GridService.__init__(self, addr, port, post, reference)
        self.grid_service_dict = {}

    def register(self, service):
        """Register a handle to a service, so we can use it's GSH to find a GSR.
        """
        url_tuple = ('http','%s:%d'%(self.addr,self.port),service.post,None,None,None)
        handle = urlparse.urlunparse(url_tuple)
        self.grid_service_dict[handle] = service

    def findByHandle(self, *args):
        msg = args[0]
        print_debug('HandleResolverService.findByHandle: ', msg._handleSet._handle)

        if msg:
            urls = msg._handleSet._handle
        else:
            urls = (self.post,)
        handle = urls[0]

        pyobj = FindByHandleOutputMessageWrapper()
        pyobj._locator = ns1.LocatorType_Def(name="locator")
        pyobj._locator._reference = ns1.WSDLReferenceType_Def(name='reference')
        try:
            service = self.grid_service_dict[handle]
        except KeyError, ex:
            print_debug("missing GSH(%s) in grid_service_dict" %handle, self.grid_service_dict)
            return
        else:
            print_debug( "FOUND SERVICE: ", service)
        pyobj._locator._reference._dom = service.getReference()
        return pyobj


