################################################## 
# SecureContextEstablishment_services_types.py 
# generated by ZSI.wsdl2python 
# 
# 
##################################################
import types
import ZSI
from ZSI import _seqtypes
from pyGridWare.ogsi import TCmodified
from pyGridWare.ogsi.TCmodified import AnyElement, Struct

def SetNamespaceDict(iDict):
    """This function sets up known namespaces in a class variable
       dictionary.  Used for parsing when a wildcard declaration
       is parsed, and for type-checking when serialing.
    """
    AnyElement.tns_module_class_dict = iDict

############################## 
# targetNamespace 
#
# http://ogsa.globus.org/security/authentication/types 
##############################


# imported as: ns1
class ogsa_globus_org_security_authentication_types:
    targetNamespace = 'http://ogsa.globus.org/security/authentication/types'
    kw = {\
        'inorder':0, 
        'unique':1, 
        'typed':1, 
        targetNamespace:'ogsa_secu_auth_type',
        }

    class ContextTokenOutType_Def(Struct):
        attributeTypes = {\
            'continue-needed':ZSI.TC.Boolean,
             }
        attributeNS = {\
            'continue-needed':'http://ogsa.globus.org/security/authentication/types',
            }
        def __init__(self, pname, **kw):
            if type(pname) in _seqtypes: 
                aname = "_%s" % pname[1]
            else:
                aname = "_%s" % pname
                pname = (self.schema,pname)

            kw.update(ns1.kw)
            if not kw.has_key('type'):
                kw['type'] = self.type

            self._base64Token = None
            self._context_id = None

            Struct.__init__(self, 
                pyclass=self.__class__,
                ofwhat=[TCmodified.Base64Binary(pname="base64Token",aname="_base64Token",oname="%s:base64Token" %kw[self.schema],**kw), \
                    ZSI.TC.String(pname="context-id",aname="_context_id",oname="%s:context-id" %kw[self.schema],**kw), ],
                pname=pname,
                aname=aname,
                **kw)

    ContextTokenOutType_Def.schema = targetNamespace
    ContextTokenOutType_Def.type = (targetNamespace, 'ContextTokenOutType')


    class ContextTokenType_Def(Struct):
        #attributeTypes = {\
        #    'continue-needed':ZSI.TC.Boolean('continue-needed'),
        #    'mechanism-type':ZSI.TC.String('mechanism-type'),
        #     }
        attributeTypes = {\
            'continue-needed':ZSI.TC.Boolean,
            'mechanism-type':ZSI.TC.String,
             }
        attributeNS = {\
            'continue-needed':'http://ogsa.globus.org/security/authentication/types',
            'mechanism-type':'http://ogsa.globus.org/security/authentication/types',
            }

        def __init__(self, pname, **kw):
            if type(pname) in _seqtypes: 
                aname = "_%s" % pname[1]
            else:
                aname = "_%s" % pname
                pname = (self.schema,pname)

            kw.update(ns1.kw)
            if not kw.has_key('type'):
                kw['type'] = self.type

            self.attributes = {}
            self._base64Token = None
            self._context_id = None

            Struct.__init__(self, 
                pyclass=self.__class__, 
                ofwhat=[TCmodified.Base64Binary(pname="base64Token",aname="_base64Token",oname="%s:base64Token" %kw[self.schema],**kw), \
                    ZSI.TC.String(pname="context-id",aname="_context_id",oname="%s:context-id" %kw[self.schema],**kw), ],
                pname=pname, 
                aname=aname, 
                **kw)

        def setAttribute_continue_needed(self, attribute):
            if isinstance(attribute, types.BooleanType):
                self.attributes['continue-needed'] = attribute
            else:
                raise RuntimeError, 'bad attribute type, expecting %s' %types.BooleanType

        def setAttribute_mechanism_type(self, attribute):
            attr_key = 'mechanism-type'
            if isinstance(attribute, types.StringType):
                self.attributes['mechanism-type'] = attribute
            else:
                raise RuntimeError, 'bad attribute type, expecting %s' %types.StringType

    ContextTokenType_Def.schema = targetNamespace
    ContextTokenType_Def.type = (targetNamespace, 'ContextTokenType')


    class ContextTokenOutElementType_Def(Struct):
        def __init__(self, pname, **kw):
            if type(pname) in _seqtypes: 
                aname = "_%s" % pname[1]
            else:
                aname = "_%s" % pname
                pname = (self.schema,pname)

            kw.update(ns1.kw)
            if not kw.has_key('type'):
                kw['type'] = self.type

            self._contextTokenOut = ns1.ContextTokenOutType_Def(pname=(ns1.targetNamespace,"contextTokenOut"))
            Struct.__init__(\
                self, 
                self.__class__,
                [ns1.ContextTokenOutType_Def(pname=(ns1.targetNamespace,"contextTokenOut")),],
                pname=pname,
                aname=aname,
                **kw)

    ContextTokenOutElementType_Def.schema = targetNamespace
    ContextTokenOutElementType_Def.type = (targetNamespace, 'ContextTokenOutElementType')


    class InitContextTokenType_Def(ContextTokenType_Def):
        def __init__(self, pname, **kw):
            if type(pname) in _seqtypes: 
                aname = "_%s" % pname[1]
            else:
                aname = "_%s" % pname
                pname = (self.schema,pname)

            kw.update(ns1.kw)
            if not kw.has_key('type'):
                kw['type'] = self.type
           
            # EXTENSION
            ns1.ContextTokenType_Def.__init__(self, pname=pname, **kw)
            extensions = []
            self.ofwhat += tuple(extensions)
            self.lenofwhat += len(extensions)

    InitContextTokenType_Def.schema = targetNamespace
    InitContextTokenType_Def.type = (targetNamespace, 'InitContextTokenType')


    class ContextTokenElementType_Def(Struct):
        def __init__(self, pname, **kw):
            if type(pname) in _seqtypes: 
                aname = "_%s" % pname[1]
            else:
                aname = "_%s" % pname
                pname = (self.schema,pname)

            kw.update(ns1.kw)
            if not kw.has_key('type'):
                kw['type'] = self.type

            self._contextToken = ns1.ContextTokenType_Def(pname=(ns1.targetNamespace, "contextToken"), **kw)
            Struct.__init__(\
                self, 
                self.__class__, 
                [ns1.ContextTokenType_Def(pname=(ns1.targetNamespace, "contextToken"), **kw),],
                pname=pname, 
                aname=aname,
                **kw
                )
    ContextTokenElementType_Def.schema = targetNamespace
    ContextTokenElementType_Def.type = (targetNamespace, 'ContextTokenElementType')


    class InitContextTokenElementType_Def(Struct):
        """Problems:
           1. Definition is in a different namespace then the containing delcaration.
              a.  Struct oname will contain element declaration namespace
              b.  element varibles should be in the definition namespace.

              solution:  
                  Definition -- 
                      ns parameter None  -- encoded.
                      ns --> Struct (element declaration)
                      
        """
        def __init__(self, pname, **kw):
            if type(pname) in _seqtypes: 
                aname = "_%s" % pname[1]
            else:
                aname = "_%s" % pname
                pname = (self.schema,pname)

            kw.update(ns1.kw)
            if not kw.has_key('type'):
                kw['type'] = self.type

            self._initContextToken = ns1.InitContextTokenType_Def(pname=(ns1.targetNamespace,"initContextToken"), **kw)
            Struct.__init__(\
                self, 
                pyclass=self.__class__, 
                ofwhat=[ns1.InitContextTokenType_Def(pname=(ns1.targetNamespace,"initContextToken"), **kw), ],
                pname=pname, 
                aname=aname,
                **kw
                )

    InitContextTokenElementType_Def.schema = targetNamespace
    InitContextTokenElementType_Def.type = (targetNamespace, 'InitContextTokenElementType')


# define class alias for subsequent ns classes
ns1 = ogsa_globus_org_security_authentication_types


############################## 
# targetNamespace 
#
# http://ogsa.globus.org/security/authentication 
##############################


# imported as: ns2

class ogsa_globus_org_security_authentication:
    targetNamespace = 'http://ogsa.globus.org/security/authentication'
    kw = {\
        'inorder':0, 
        'unique':1, 
        'typed':1, 
        targetNamespace:'ogsa_secu_auth',
        }

    class initTokenExchange_Dec(ns1.InitContextTokenElementType_Def):
        literal = "initTokenExchange"

        def __init__(self, name=None, ns=None, **kw):
            """problems with all element declarations.
               1) can't pass __class__.schema in. ??
               2) All declarations should already know their name
               3) FOR TCmodified: calling base class constructor NEEDS name and ns
            """
            name = self.__class__.literal
            ns = ns or self.__class__.schema

            kw.update(ns2.kw)
            pname = (ns,name)

            ns1.InitContextTokenElementType_Def.__init__(self, pname=pname, **kw)
            self.typecode = ns1.InitContextTokenElementType_Def(pname=pname, **kw)

    initTokenExchange_Dec.schema = targetNamespace


    class continueTokenExchangeResponse_Dec(ns1.ContextTokenOutElementType_Def):
        literal = "continueTokenExchangeResponse"

        def __init__(self, name=None, ns=None, **kw):
            name = self.__class__.literal
            ns = ns or self.__class__.schema

            kw.update(ns2.kw)
            pname = (ns,name)

            ns1.ContextTokenOutElementType_Def.__init__(self, pname=pname, **kw)
            self.typecode = ns1.ContextTokenOutElementType_Def(pname=pname, **kw)

    continueTokenExchangeResponse_Dec.schema = targetNamespace


    class initTokenExchangeResponse_Dec(ns1.ContextTokenOutElementType_Def):
        literal = "initTokenExchangeResponse"

        def __init__(self, name=None, ns=None, **kw):
            name = self.__class__.literal
            ns = ns or self.__class__.schema

            kw.update(ns2.kw)
            pname = (ns,name)

            ns1.ContextTokenOutElementType_Def.__init__(self, pname=pname, **kw)
            self.typecode = ns1.ContextTokenOutElementType_Def(pname=pname, **kw)

    initTokenExchangeResponse_Dec.schema = targetNamespace


    class continueTokenExchange_Dec(ns1.ContextTokenElementType_Def):
        literal = "continueTokenExchange"

        def __init__(self, name=None, ns=None, **kw):
            name = self.__class__.literal
            ns = ns or self.__class__.schema

            kw.update(ns2.kw)
            pname = (ns,name)

            ns1.ContextTokenElementType_Def.__init__(self, pname=pname, **kw)
            self.typecode = ns1.ContextTokenElementType_Def(pname=pname, **kw)

    continueTokenExchange_Dec.schema = targetNamespace


# define class alias for subsequent ns classes
ns2 = ogsa_globus_org_security_authentication
