#! /usr/bin/env python
# $Header: /home/portnoy/u5/repository/pyGridWare/pyGridWare/ogsi/writer.py,v 1.1 2003/10/18 01:15:45 boverhof Exp $
'''SOAP message serialization.
'''
from xml.dom.ext import c14n
from xml.dom import minidom


import cStringIO as StringIO
from ZSI import _copyright, ZSI_SCHEMA_URI
from ZSI import _stringtypes, _seqtypes
from ZSI.TC import TypeCode
try:
    from xml.dom.ext import Canonicalize
    from xml.ns import XMLNS, SOAP, SCHEMA
except:
    from ZSI.compat import Canonicalize, XMLNS, SOAP, SCHEMA
import types

_standard_ns = [ ('xml', XMLNS.XML), ('xmlns', XMLNS.BASE) ]

_reserved_ns = {
        'SOAP-ENV': SOAP.ENV,
        'SOAP-ENC': SOAP.ENC,
        'ZSI': ZSI_SCHEMA_URI,
        'xsd': SCHEMA.BASE,
        'xsi': SCHEMA.BASE + '-instance',
}

class SoapWriter:
    '''SOAP output formatter.'''

    def __init__(self, out,
    envelope=1, encoding=SOAP.ENC, header=None, nsdict=None, **kw):
        self.out, self.callbacks, self.memo, self.closed = \
            out, [], [], 0
        nsdict = nsdict or {}
        self.envelope = envelope
        self.encoding = encoding

        if not self.envelope: return
        print >>self, '<?xml version="1.0" encoding="utf-8"?>'
        print >>self, '<SOAP-ENV:Envelope\n' \
            '  xmlns:SOAP-ENV="%(SOAP-ENV)s"\n' \
            '  xmlns:SOAP-ENC="%(SOAP-ENC)s"\n' \
            '  xmlns:xsi="%(xsi)s"\n' \
            '  xmlns:xsd="%(xsd)s"\n' \
            '  xmlns:ZSI="%(ZSI)s"' % _reserved_ns,
        if self.encoding:
            print >>self, '\n  SOAP-ENV:encodingStyle="%s"' % self.encoding,
        print >>self, '>'

        self.nsdict = nsdict
        self.header = header
        """
        s = StringIO.StringIO()
        self.serialize_body(header, s)


        print >>bug.getvalue()
        print >>self, '<SOAP-ENV:Body'
        if nsdict: self.writeNSdict(nsdict)
        print >>self, '>'
        """

    def serialize_head_DOM(self, header, out):
        #out = StringIO.StringIO()
        if header:
            #print >>out, '<SOAP-ENV:Header>'
            if type(header) in _stringtypes:
                print >>out, header,
                if header[-1] not in ['\r', '\n']: print >>out
            else:
                for n in header:
                    #Canonicalize(n, out, nsdict=nsdict)
                    Canonicalize(n, out, nsdict=self.nsdict)
                    print >>out
            #print >>out, '</SOAP-ENV:Header>'
        #return out

    def serialize_head_TC(self, header, out, **kw):
        return self.serialize_typecode(header, typecode=None, root=None, **kw)
        
    def serialize_head(self, header, out, **kw):
        if isinstance(header, TypeCode):
            self.serialize_head_TC(header, out)
        else:
            self.serialize_head_DOM(header, out)

    def serialize_typecode(self,  pyobj, typecode=None, root=None, **kw):
        '''Serialize a Python object to the output stream.
        '''
        if typecode is None: typecode = pyobj.__class__.typecode
        if TypeCode.typechecks and type(pyobj) == types.InstanceType and \
        not hasattr(typecode, 'pyclass'):
            pass
            # XXX XML ...
#           raise TypeError('Serializing Python object with other than Struct.')
        kw = kw.copy()
        if root in [ 0, 1 ]:
            kw['attrtext'] = ' SOAP-ENC:root="%d"' % root
        s = StringIO.StringIO()
        #typecode.serialize(self, pyobj, **kw)
        typecode.serialize(s, pyobj, **kw)

        #return self
        return s

    def serialize(self, pyobj, typecode=None, root=None, **kw):
        '''Serialize a Python object to the output stream.
           Now we can look at the xml instance and create a 
           signature, then write it in the SOAPENV:Header.
        '''
        sB = self.serialize_typecode(pyobj, typecode=None, root=None, **kw)
        # ---------------------------------------
        # Do some calculations and set header fields.
        header = None
        ws_security = 1
        #tag_ns = ('add', 'http://ogsa.globus.org/samples/counter')
        body = sB.getvalue()
        if ws_security:
            dom = minidom.parseString(body)
            #nodes = dom.getElementsByTagNameNS(tag_ns)
            print "DOM: ", dom
            nodes = dom.childNodes

            #
            #CAN WE JUST CANONICALIZE THE ENTIRE BODY and call it good?
            #
            for node in nodes:
                can = c14n.Canonicalize(node)
                print "CAN: ", can
            body = sB.getvalue()
           
            digest_value = "d0NnYcUb+/5uh63c9UfKB6Nzk3E="
            signature_value = "AAAAAAAAAAQAAALI0QDmmYmEwGFEXdPl+8WpO7iOb9U="
            keyname = "00000000-01b3-1fd9-00000000-00000120a48c"
           
            header = """
<wsse:Security xmlns:wsse="http://schemas.xmlsoap.org/ws/2002/04/secext" 
    soapenv:actor="" soapenv:mustUnderstand="0">
<ds:Signature xmlns:ds="http://www.w3.org/2000/09/xmldsig#">
<ds:SignedInfo>
<ds:CanonicalizationMethod Algorithm="http://www.w3.org/TR/2001/REC-xml-c14n-20010315"></ds:CanonicalizationMethod>
<ds:SignatureMethod Algorithm="http://www.globus.org/2002/04/xmlenc#gssapi-sign"></ds:SignatureMethod>
<ds:Reference URI="#digestSource">
<ds:DigestMethod Algorithm="http://www.w3.org/2000/09/xmldsig#sha1"></ds:DigestMethod>
<ds:DigestValue>%s</ds:DigestValue>
</ds:Reference>
</ds:SignedInfo>
<ds:SignatureValue>%s</ds:SignatureValue>
<ds:KeyInfo>
<ds:KeyName>%s</ds:KeyName>
</ds:KeyInfo>
</ds:Signature>
</wsse:Security>""" %(digest_value, signature_value, keyname)
        else:
            body = sB.getvalue()


        # ---------------------------------------
        out = StringIO.StringIO()
        self.serialize_head(self.header, out)

        #header = out.getvalue()
        if header:
            print >>self, '<SOAP-ENV:Header>'
            print >>self, header
            print >>self, '</SOAP-ENV:Header>'

        print >>self, '<SOAP-ENV:Body'
        if self.nsdict: self.writeNSdict(self.nsdict)
        print >>self, '>'
        print >>self, body


    def write(self, arg):
        '''Write convenience function; writes a string, but will also
        iterate through a sequence (recursively) of strings.
        '''
        if type(arg) in _seqtypes:
            W = self.out.write
            for a in arg:
                if a is not None: W(a)
        else:
            self.out.write(arg)

    def writeNSdict(self, nsdict):
        '''Write a namespace dictionary, taking care to not clobber the
        standard (or reserved by us) prefixes.
        '''
        for k,v in nsdict.items():
            if (k,v) in _standard_ns: continue
            rv = _reserved_ns.get(k)
            if rv:
                if rv != v:
                    raise KeyError("Reserved namespace " + str((k,v)) + " used")
                continue
            if k:
                print >>self, '\n  xmlns:%s="%s"' % \
                        (k, v.replace('"', "&quot;")),
            else:
                print >>self, '\n  xmlns="%s"' % v.replace('"', "&quot;"),

    def ReservedNS(self, prefix, uri):
        '''Is this namespace (prefix,uri) reserved by us?
        '''
        return _reserved_ns.get(prefix, uri) != uri

    def AddCallback(self, func, *arglist):
        '''Add a callback function and argument list to be invoked before
        closing off the SOAP Body.
        '''
        self.callbacks.append((func, arglist))

    def Known(self, obj):
        '''Seen this object (known by its id()?  Return 1 if so,
        otherwise add it to our memory and return 0.
        '''
        obj = id(obj)
        if obj in self.memo: return 1
        self.memo.append(obj)
        return 0

    def Forget(self, obj):
        '''Forget we've seen this object.
        '''
        obj = id(obj)
        try:
            self.memo.remove(obj)
        except ValueError:
            pass

    def close(self, trailer=None, nsdict=None):
        '''Invoke all the callbacks, and close off the SOAP message.
        '''
        for func,arglist in self.callbacks:
            apply(func, (self,) + arglist)
        if self.envelope: print >>self, '</SOAP-ENV:Body>'
        if type(trailer) in _stringtypes:
            print >>self, trailer
        elif trailer is not None:
            for n in trailer:
                Canonicalize(n, self, nsdict=nsdict or _reserved_ns)
                print >>self
        if self.envelope: print >>self, '</SOAP-ENV:Envelope>'
        self.closed = 1

    def __del__(self):
        if not self.closed: self.close()

if __name__ == '__main__': print _copyright
