from distutils.core import setup, Extension
from distutils.spawn import spawn
from distutils.sysconfig import get_python_inc
from os import environ, popen4
from os.path import isfile
import sys, string, re, exceptions


def run_happydoc():
    doc = ["happydoc", "-d", "./doc", "pyGridWare", "formatter_levelOneHeadingBackgroundColor='#CCCCCC'", "formatter_levelOneHeadingForegroundColor='000000'", "formatter_levelTwoHeadingBackgroundColor='#CCCCCC'", "formatter_levelTwoHeadingForegroundColor='000000'", "./pyGridWare"]
    spawn(doc, verbose=1)
    return

def main():
    debug = 0
    happydoc = 0

    for arg in sys.argv[1:]:
        if string.find(arg, '--run-happydoc') == 0:
            happydoc = 1
            sys.argv.remove(arg)
        elif string.find(arg, '--debug') == 0:
	    debug = 1
	    sys.argv.remove(arg)

    setup(name="pyGridWare", 
          version="0.0.1", 
          packages=["pyGridWare", "pyGridWare.ogsi", "pyGridWare.ogsi.services", \
                    "pyGridWare.ogsi.samples",  "pyGridWare.ogsi.security"],
          description="python grid services",
	  author="Joshua Boverhof", 
          author_email="JRBoverhof@lbl.gov",
          maintainer="Joshua Boverhof", 
          maintainer_email="JRBoverhof@lbl.gov",
	  url="http://www-itg.lbl.gov/gtg/pyGridWare/")

    if happydoc:
	run_happydoc()
	

if __name__ == '__main__': main()
